/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the LocalizedText type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LocalizedText{}

// LocalizedText struct for LocalizedText
type LocalizedText struct {
	Locale *string `json:"locale,omitempty"`
	Text *string `json:"text,omitempty"`
}

// NewLocalizedText instantiates a new LocalizedText object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLocalizedText() *LocalizedText {
	this := LocalizedText{}
	return &this
}

// NewLocalizedTextWithDefaults instantiates a new LocalizedText object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLocalizedTextWithDefaults() *LocalizedText {
	this := LocalizedText{}
	return &this
}

// GetLocale returns the Locale field value if set, zero value otherwise.
func (o *LocalizedText) GetLocale() string {
	if o == nil || IsNil(o.Locale) {
		var ret string
		return ret
	}
	return *o.Locale
}

// GetLocaleOk returns a tuple with the Locale field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LocalizedText) GetLocaleOk() (*string, bool) {
	if o == nil || IsNil(o.Locale) {
		return nil, false
	}
	return o.Locale, true
}

// HasLocale returns a boolean if a field has been set.
func (o *LocalizedText) HasLocale() bool {
	if o != nil && !IsNil(o.Locale) {
		return true
	}

	return false
}

// SetLocale gets a reference to the given string and assigns it to the Locale field.
func (o *LocalizedText) SetLocale(v string) {
	o.Locale = &v
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *LocalizedText) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LocalizedText) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *LocalizedText) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *LocalizedText) SetText(v string) {
	o.Text = &v
}

func (o LocalizedText) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LocalizedText) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Locale) {
		toSerialize["locale"] = o.Locale
	}
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	return toSerialize, nil
}

type NullableLocalizedText struct {
	value *LocalizedText
	isSet bool
}

func (v NullableLocalizedText) Get() *LocalizedText {
	return v.value
}

func (v *NullableLocalizedText) Set(val *LocalizedText) {
	v.value = val
	v.isSet = true
}

func (v NullableLocalizedText) IsSet() bool {
	return v.isSet
}

func (v *NullableLocalizedText) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLocalizedText(val *LocalizedText) *NullableLocalizedText {
	return &NullableLocalizedText{value: val, isSet: true}
}

func (v NullableLocalizedText) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLocalizedText) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


